CDECK  ID>, HWBGUP.
*CMZ :-        -16/07/02  09.40.25  by  Peter Richardson
*-- Author :    Peter Richardson
C----------------------------------------------------------------------
      SUBROUTINE HWBGUP(ISTART,ICMF)
C----------------------------------------------------------------------
C     Makes the colour connections and performs the parton shower
C     for events read in from the GUPI (Generic User Process Interface)
C     event common block
C----------------------------------------------------------------------
#include "HERWIG65.INC"
      INTEGER MAXNUP
      PARAMETER (MAXNUP=500)
      INTEGER NUP,IDPRUP,IDUP,ISTUP,MOTHUP,ICOLUP
      DOUBLE PRECISION XWGTUP,SCALUP,AQEDUP,AQCDUP,PUP,VTIMUP,SPINUP
      COMMON/HEPEUP/NUP,IDPRUP,XWGTUP,SCALUP,AQEDUP,AQCDUP,
     &              IDUP(MAXNUP),ISTUP(MAXNUP),MOTHUP(2,MAXNUP),
     &              ICOLUP(2,MAXNUP),PUP(5,MAXNUP),VTIMUP(MAXNUP),
     &              SPINUP(MAXNUP)
C--Local variables
      INTEGER ISTART,ICMF,J,K,I,JCOL,ICOL
      LOGICAL FOUND
      COMMON /HWGUP/ILOC(NMXHEP),JLOC(MAXNUP)
      INTEGER ILOC,JLOC
C--now we need to do the colour connections
 20   ISTART = ISTART+1
      IF(ISTART.GT.NHEP) GOTO 30
      IF(ISTART.EQ.ICMF) ISTART = ISTART+1
      IF(JMOHEP(2,ISTART).NE.0.AND.JDAHEP(2,ISTART).NE.0) GOTO 20
      K = ISTART
      J = ILOC(K)
      IF(ICOLUP(1,J).NE.0) THEN
        JCOL = 1
        ICOL = ICOLUP(1,J)
      ELSE
        JCOL = 2
        ICOL = ICOLUP(2,J)
      ENDIF
      IF(ICOL.EQ.0) THEN
        JMOHEP(2,K) = K
        JDAHEP(2,K) = K
        GOTO 20
      ENDIF
C--now search for the partner
C--first search for the flavour partner if not looking for colour partner
C--search for the flavour partner of the particle
C--this must be set or HERWIG won't work
 10   IF(JDAHEP(2,K).NE.0.AND.JMOHEP(2,K).NE.0) GOTO 20
      IF(ICOL.EQ.0) THEN
        FOUND = .FALSE.
C--look for unpaired particle
        DO 15 I=1,NUP
          IF(JLOC(I).EQ.0) GOTO 15
          IF(IDUP(I).EQ.21.OR.IDUP(I).EQ.9) GOTO 15
          IF(JLOC(I).EQ.ISTART) GOTO 15
          IF(ICOLUP(1,I).EQ.0.AND.ICOLUP(2,I).EQ.0) GOTO 15
C--antiflavour partner
          IF(JDAHEP(2,JLOC(I)).EQ.0) THEN
C--pair incoming     particle with outgoing     particle
C-- or  outgoing antiparticle with outgoing     particle
            IF(ISTUP(I).GT.0.AND.IDUP(I).GT.0.AND.
     &         ((IDUP(J).GT.0.AND.ISTUP(J).EQ.-1).OR.
     &          (IDUP(J).LT.0.AND.ISTUP(J).GT.0 )))  THEN
              FOUND = .TRUE.
              JCOL = 1
C--pair incoming     particle with incoming antiparticle
C-- or  outgoing antiparticle with incoming antiparticle
            ELSEIF(IDUP(I).LT.0.AND.ISTUP(I).EQ.-1.AND.
     &             ((IDUP(J).GT.0.AND.ISTUP(J).EQ.-1).OR.
     &              (IDUP(J).LT.0.AND.ISTUP(J).GT.0 ))) THEN
              FOUND = .TRUE.
              JCOL = 2
            ENDIF
C--make the connection
            IF(FOUND) THEN
              JMOHEP(2,K)       = JLOC(I)
              JDAHEP(2,JLOC(I)) = K
            ENDIF
          ENDIF
C--flavour partner
          IF(JMOHEP(2,JLOC(I)).EQ.0.AND.(.NOT.FOUND)) THEN
C--pair incoming antiparticle with outgoing antiparticle
C-- or  outgoing     particle with outgoing antiparticle
            IF(IDUP(I).LT.0.AND.ISTUP(I).GT.0.AND.
     &         ((IDUP(J).LT.0.AND.ISTUP(J).EQ.-1).OR.
     &          (IDUP(J).GT.0.AND.ISTUP(J).GT.0 ))) THEN
              FOUND = .TRUE.
              JCOL = 2
C--pair incoming antiparticle with incoming     particle
C-- or  outgoing     particle with incoming     particle
            ELSEIF(IDUP(I).GT.0.AND.ISTUP(I).EQ.-1.AND.
     &             ((IDUP(J).LT.0.AND.ISTUP(J).EQ.-1).OR.
     &              (IDUP(J).GT.0.AND.ISTUP(J).GT.0 ))) THEN
              FOUND = .TRUE.
              JCOL = 1
            ENDIF
C--make the connection
            IF(FOUND) THEN
              JDAHEP(2,K) = JLOC(I)
              JMOHEP(2,JLOC(I)) = K
            ENDIF
          ENDIF
C--set up the search for the next partner
          IF(FOUND) THEN
            FOUND = .FALSE.
            ICOL = ICOLUP(JCOL,I)
            K = JLOC(I)
            J = I
            GOTO 10
          ENDIF
 15     CONTINUE
C--if no other choice then connect to the first particle in the loop
        IF(JDAHEP(2,K).EQ.0.AND.JMOHEP(2,ISTART).EQ.0) THEN
           JDAHEP(2,K) = ISTART
           JMOHEP(2,ISTART) = K
        ELSEIF(JDAHEP(2,ISTART).EQ.0.AND.JMOHEP(2,K).EQ.0) THEN
           JMOHEP(2,K) = ISTART
           JDAHEP(2,ISTART) = K
        ELSE
          CALL HWWARN('HWBGUP',100)
          GOTO 999
        ENDIF
        GOTO 20
      ENDIF
C--now the bit to find colour partners
      FOUND = .FALSE.
C--special for particle from a decaying coloured particle
      IF(MOTHUP(1,J).NE.0) THEN
        IF(ISTUP(MOTHUP(1,J)).EQ.2.OR.ISTUP(MOTHUP(1,J)).EQ.3) THEN
          IF(IDUP(J).LT.0.AND.ICOL.EQ.ICOLUP(2,MOTHUP(1,J))) THEN
            JDAHEP(2,K) = JLOC(MOTHUP(1,J))
            JMOHEP(2,K) = JLOC(MOTHUP(1,J))
            GOTO 20
          ELSEIF(IDUP(J).GT.0.AND.ICOL.EQ.ICOLUP(1,MOTHUP(1,J))) THEN
            JDAHEP(2,K) = JLOC(MOTHUP(1,J))
            JMOHEP(2,K) = JLOC(MOTHUP(1,J))
            GOTO 20
          ENDIF
        ENDIF
      ENDIF
C--search for the partner
      DO I=1,NUP
        IF(ICOLUP(1,I).EQ.ICOL.AND.I.NE.J) THEN
          IF((JCOL.EQ.1.AND.ISTUP(J).EQ.-1.AND.ISTUP(I).GT.0).OR.
     &       (JCOL.EQ.2.AND.ISTUP(J).GT.0.AND.ISTUP(I).GE.0)) THEN
            JDAHEP(2,K)       = JLOC(I)
            JMOHEP(2,JLOC(I)) = K
            FOUND = .TRUE.
          ELSEIF((JCOL.EQ.1.AND.ISTUP(J).GT.0.AND.ISTUP(I).EQ.-1).OR.
     &          (JCOL.EQ.2.AND.ISTUP(J).EQ.-1.AND.ISTUP(I).EQ.-1)) THEN
            JMOHEP(2,K)       = JLOC(I)
            JDAHEP(2,JLOC(I)) = K
            FOUND = .TRUE.
          ENDIF
          IF(FOUND) JCOL = 2
        ELSEIF(ICOLUP(2,I).EQ.ICOL.AND.I.NE.J) THEN
          IF((JCOL.EQ.1.AND.ISTUP(J).EQ.-1.AND.ISTUP(I).EQ.-1).OR.
     &       (JCOL.EQ.2.AND.ISTUP(J).GT.0.AND.ISTUP(I).EQ.-1)) THEN
            JDAHEP(2,K) = JLOC(I)
            JMOHEP(2,JLOC(I)) = K
            FOUND = .TRUE.
          ELSEIF((JCOL.EQ.1.AND.ISTUP(J).GE.0.AND.ISTUP(I).GE.0).OR.
     &           (JCOL.EQ.2.AND.ISTUP(J).EQ.-1.AND.ISTUP(I).GE.0)) THEN
            JMOHEP(2,K) = JLOC(I)
            JDAHEP(2,JLOC(I)) = K
            FOUND = .TRUE.
          ENDIF
          IF(FOUND) JCOL = 1
        ENDIF
        IF(FOUND) THEN
          K = JLOC(I)
          J = I
          ICOL = ICOLUP(JCOL,I)
          GOTO 10
        ENDIF
      ENDDO
C--special for self connected gluons
      IF(IDUP(J).EQ.21.OR.IDUP(J).EQ.9.AND.
     &     ICOLUP(1,J).EQ.ICOLUP(2,J)) THEN
        JMOHEP(2,K) = K
        JDAHEP(2,K) = K
C--options for self connected gluons
        IF(LHGLSF) THEN
          CALL HWWARN('HWBGUP',1)
        ELSE
          CALL HWWARN('HWBGUP',101)
          GOTO 999
        ENDIF
        GOTO 20
      ENDIF
C--perform the shower
 30   CALL HWBGEN
C--recompute spectator etc if process was direct photoproduction
      J=JDAHEP(1,1)
      IF (J.LE.0) RETURN
      IF (IDHEP(J).NE.22) RETURN
      DO I=J+1,NHEP
         IF (IDHEP(I).EQ.22.AND.ISTHEP(I).EQ.3) THEN
            K=I
            GOTO 40
         ENDIF
      ENDDO
      RETURN
 40   CALL HWVEQU(4,PHEP(1,K),PHEP(1,J))
      CALL HWVSUM(4,PHEP(1,K),PHEP(1,2),PHEP(1,3))
      CALL HWUMAS(PHEP(1,3))
      J=JDAHEP(2,1)
      CALL HWVDIF(4,PHEP(1,1),PHEP(1,K),PHEP(1,J))
      CALL HWUMAS(PHEP(1,J))
 999  RETURN
      END
